class CreativeCoding {

  float t=0, dt=0.01;
  int   i, j, k, codeType=1, numContour=0;
  ArrayList<PVector> [] contour;
  
  CreativeCoding() {
  }

  void clear() {
    for(i=0; i<numContour; i++)
      contour[i].clear();  
    numContour=0;  
  }

  void create(int numContour) {
    contour = (ArrayList<PVector>[])new ArrayList[numContour];
    for(i=0; i<numContour; i++)
      contour[i] = new ArrayList<PVector>();
    this.numContour=numContour;  
  }
  
  void add(int i, int x, int y) {
    contour[i].add(new PVector(x, y));  
  }
  
  void setCodeType(int codeType) {
    this.codeType=codeType+1;
  }
  
  void draw() {
    if(codeType==1) draw1();
    else if(codeType==2) draw2();
    else if(codeType==3) draw3();
    else if(codeType==4) draw4();
    else if(codeType==5) draw5();
    else if(codeType==6) draw6();
    else if(codeType==7) draw7();
    else if(codeType==8) draw8();
    else if(codeType==9) draw9();
    fill(0, 0, 100);
    text("codeType:"+codeType+" minMargin:"+minMargin+" displayInterval:"+displayInterval, 30, 30);
    text("123456789 mM pP f h v d Space @ CreativeCoding", 30, 60);
    text(numContour, 30, 90);
    for (i=0; i<numContour; i++) text(contour[i].size(), 60+50*i, 90);
  }
  
  void draw1() {
    t+=dt;
    strokeWeight(1);
    stroke(0, 0, 100);
    fill(noise(t)*360, 100, 100);
    for (i=0; i<numContour; i++) {
      for (j=0; j<contour[i].size(); j++) {
        PVector v = contour[i].get(j);
        ellipse(v.x, v.y, displayInterval, displayInterval);
      }
    }  
  }

  void draw2() {
    strokeWeight(displayInterval);
    for (i=0; i<numContour; i++) {
      int l=contour[i].size()-1;
      for (j=0; j<l; j++) {
        stroke(360.*j/l, 100, 100);
        PVector v1 = contour[i].get(j);
        PVector v2 = contour[i].get(j+1);
        line(v1.x, v1.y, v2.x, v2.y);
      }
    }  
  }
  
  void draw3() {
    int r=displayInterval/3+1;
    strokeWeight(2);
    for (i=0; i<numContour; i++) {
      int l=contour[i].size()-1;
      for (j=0; j<l; j++) {
        stroke(360.*j/l, 100, 100);
        PVector v1 = contour[i].get(j);
        PVector v2 = contour[i].get(j+1);
        float dx=(v2.x-v1.x)*displayInterval;
        float dy=(v2.y-v1.y)*displayInterval;
        line(v1.x, v1.y, v1.x+dy, v1.y-dx);
        stroke(0, 0, 100);
        ellipse(v1.x, v1.y, r, r);
        ellipse(v1.x+dy, v1.y-dx, r, r);
      }
    }  
  }
  
  void draw4() {
    int n=displayInterval/2+1;
    noFill();
    for (i=0; i<numContour; i++) {
      int l=contour[i].size()-1;
      for(k=0; k<n; k++) {
        strokeWeight(n-k+1);
        stroke(0, 0, 100-k*70/n);
        beginShape();
        for (j=0; j<l; j++) {
          PVector v1 = contour[i].get(j);
          PVector v2 = contour[i].get(j+1);
          float dx=(v2.x-v1.x)*k;
          float dy=(v2.y-v1.y)*k;
          vertex(v1.x+dy, v1.y-dx);
        }
        endShape();
      }  
    }  
  }

  void draw5() {
    int n=displayInterval/2+1;
    noFill();
    strokeWeight(2);
    stroke(0, 0, 100);
    for (i=0; i<numContour; i++) {
      int l=contour[i].size();
      beginShape(LINES);
      for (j=0; j<l; j++) {
        PVector v1 = contour[i].get(j);
        PVector v2 = contour[i].get((j+n)%l);
        vertex(v1.x, v1.y);
        vertex(v2.x, v2.y);
      }
      endShape();
    }  
  }

  void draw6() {
    strokeWeight(10);
    stroke(0,0,100);
    PVector v1 = contour[0].get(0);
    point(v1.x, v1.y);
    int l=contour[0].size()-1;
    v1 = contour[0].get(l);
    point(v1.x, v1.y);
    strokeWeight(2);
    noFill();
    beginShape();
    for (i=0; i<numContour; i++) {
      l=contour[i].size()-1;
      for (j=0; j<l; j++) {
        stroke(360.*j/l, 100, 100);
        v1 = contour[i].get(j);
        vertex(v1.x, v1.y);
      }
    }
    endShape();  
  }
  
  void draw7() {
  }
  
  void draw8() {
  }
  
  void draw9() {
  }
}

